#include "CFishPoly.h"
#define ANTHIAS_COUNT  3
#define CHROMIS_COUNT  5
#define BLUE_TANG_COUNT 1
#define FLASHER_WRASSE_COUNT 4
#define FLAME_ANGEL_COUNT 1
#define YELLOW_TANG_COUNT 1
#define CHRYSURUS_COUNT	0
#define MAX_FISH_COUNT  CHRYSURUS_COUNT+ANTHIAS_COUNT+CHROMIS_COUNT+BLUE_TANG_COUNT+YELLOW_TANG_COUNT+FLASHER_WRASSE_COUNT+FLAME_ANGEL_COUNT
#define MAX_ROCK_COUNT 25
class CFishTank  {
      private:
          GLint sandTexture;
          CFishPoly m_fish[MAX_FISH_COUNT];
          CRockPoly m_rocks[MAX_ROCK_COUNT];
          int fishCount, showFishCount;
          int rockCount ;
          int tankMode;

      public:
          CFishTank();
          ~CFishTank() {static GLuint texName[1] = {sandTexture};
			              glDeleteTextures(1, texName);};
          void init();
          void draw();
          void drawTank();
 };

CFishTank::CFishTank() {
    tankMode = GL_FILL;

}

void CFishTank::init() {
    int tID1, cnt = 0;
    for (int i = 0; i < ANTHIAS_COUNT; i++) {
        if (i == 0) {
            m_fish[cnt].init(anthias, anthias_size);
            tID1 = m_fish[cnt].getTextureID();
        }
        else {
            m_fish[cnt].init(anthias, anthias_size, tID1);
        }
        cnt++;
    }
    for (i = 0; i < CHROMIS_COUNT; i++) {
        if (i == 0) {
            m_fish[cnt].init(chromis, chromis_size);
            tID1 = m_fish[cnt].getTextureID();
        }
        else {
            m_fish[cnt].init(chromis, chromis_size, tID1);
        }
        cnt++;
    }
    for (i = 0; i < BLUE_TANG_COUNT; i++) {
        if (i == 0) {
            m_fish[cnt].init(bluetang, bluetang_size);
            tID1 = m_fish[cnt].getTextureID();
        }
        else {
            m_fish[cnt].init(bluetang, bluetang_size, tID1);
        }
        cnt++;
    }
    for (i = 0; i < FLASHER_WRASSE_COUNT; i++) {
        if (i == 0) {
            m_fish[cnt].init(flasherwrasse, flasherwrasse_size);
            tID1 = m_fish[cnt].getTextureID();
        }
        else {
            m_fish[cnt].init(flasherwrasse, flasherwrasse_size, tID1);
        }
        cnt++;
    }
    for (i = 0; i < FLAME_ANGEL_COUNT; i++) {
        if (i == 0) {
            m_fish[cnt].init(flameangel, flameangel_size);
            tID1 = m_fish[cnt].getTextureID();
        }
        else {
            m_fish[cnt].init(flameangel, flameangel_size, tID1);
        }
        cnt++;
    }
    for (i = 0; i < YELLOW_TANG_COUNT; i++) {
        if (i == 0) {
            m_fish[cnt].init(yellowtang, yellowtang_size);
            tID1 = m_fish[cnt].getTextureID();
        }
        else {
            m_fish[cnt].init(yellowtang, yellowtang_size, tID1);
        }
        cnt++;
    }
	for (i = 0; i < CHRYSURUS_COUNT; i++) {
        if (i == 0) {
            m_fish[cnt].init(chrysurus, chrysurus_size);
            tID1 = m_fish[cnt].getTextureID();
        }
        else {
            m_fish[cnt].init(chrysurus, chrysurus_size, tID1);
        }
        cnt++;
    }
    fishCount = MAX_FISH_COUNT;
    showFishCount = fishCount;

    m_rocks[0].init(106, 666); // 666 is just junk
    m_rocks[0].position(-15.0,-12.0,1.0);
    tID1 = m_rocks[0].getTextureID();
    m_rocks[1].init(tID1);
    m_rocks[1].position(-14.5,-11.0,1.0);
    m_rocks[2].init(tID1);
    m_rocks[2].position(-14.0,-10.0,1.0);
    m_rocks[3].init(tID1);
    m_rocks[3].position(-13.5,-9.0,1.0);
    m_rocks[4].init(tID1);
    m_rocks[4].position(-13.0,-8.0,1.0);
    m_rocks[5].init(tID1);
    m_rocks[5].position(-12.0,-7.0,1.0);
    m_rocks[6].init(tID1);
    m_rocks[6].position(-11.0,-6.0,1.0);
    m_rocks[7].init(tID1);
    m_rocks[7].position(-2.0,-12.0,-1.0);
    m_rocks[8].init(tID1);
    m_rocks[8].position(-2.5,-11.0,-1.0);
    m_rocks[9].init(tID1);
    m_rocks[9].position(-3.0,-10.0,-1.0);
    m_rocks[10].init(tID1);
    m_rocks[10].position(-3.5,-9.0,-1.0);
    m_rocks[11].init(tID1);
    m_rocks[11].position(-3.0,-8.0,-1.0);
    m_rocks[12].init(tID1);
    m_rocks[12].position(-4.0,-7.0,-1.0);
    m_rocks[13].init(tID1);
    m_rocks[13].position(-5.0,-6.0,-1.0);
    m_rocks[14].init(tID1);
    m_rocks[14].position(-5.0,-5.0,1.0);
    m_rocks[15].init(tID1);
    m_rocks[15].position(-11.0,-5.0,1.0);
    m_rocks[16].init(tID1);
    m_rocks[16].position(-8.0,-4.0,0.0);
    rockCount = 17;

    for (i = 0; i < fishCount; i++) {
        m_fish[i].setAllFish(m_fish, fishCount);
        m_fish[i].setAllRocks(m_rocks, rockCount);
    }

    sandTexture = LoadGLTextures(107);
}

 void CFishTank::drawTank() {
    glPushMatrix();
    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
    glDisable(GL_LIGHTING);
    glBegin(GL_QUADS);
    glColor3f(0.4f,0.4f,0.4f);
    glVertex3f(-24.0f,12.0f,12.0f); 
    glVertex3f(-24.0f,12.0f,-12.0f); 
    glVertex3f(24.0f,12.0f,-12.0f);
    glVertex3f(24.0f,12.0f,12.0f);
    glEnd();
    glEnable(GL_LIGHTING);

    glPolygonMode(GL_FRONT, tankMode);
    glBindTexture(GL_TEXTURE_2D, sandTexture);
    glEnable(GL_TEXTURE_2D);
    glBegin(GL_QUADS);
    glTexCoord2f( 0.0f, 0.0f );
    glVertex3f(24.0f,-12.0f,12.0f);
    glTexCoord2f( 0.0f, 3.0f );
    glVertex3f(24.0f,-12.0f,-12.0f);
    glTexCoord2f( 6.0f, 3.0f);
    glVertex3f(-24.0f,-12.0f,-12.0f);
    glTexCoord2f( 6.0f, 0.0f );
    glVertex3f(-24.0f,-12.0f,12.0f);
    glEnd();
    glDisable(GL_TEXTURE_2D);
    glDisable(GL_LIGHTING);
    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
    glBegin(GL_QUADS);
    glColor3f(0.4f,0.4f,0.4f);
    glVertex3f(-24.0f,12.0f,12.0f);
    glVertex3f(-24.0f,-12.0f,12.0f); 
    glVertex3f(-24.0f,-12.0f,-12.0f);
    glVertex3f(-24.0f,12.0f,-12.0f);

    glVertex3f(24.0f,12.0f,-12.0f);
    glVertex3f(24.0f,-12.0f,-12.0f);
    glVertex3f(24.0f,-12.0f,12.0f);
    glVertex3f(24.0f,12.0f,12.0f);

    glVertex3f(24.0f,12.0f,-12.0f); 
    glVertex3f(-24.0f,12.0f,-12.0f); 
    glVertex3f(-24.0f,-12.0f,-12.0f);
    glVertex3f(24.0f,-12.0f,-12.0f);

    glVertex3f(-24.0f,12.0f,12.0f);
    glVertex3f(24.0f,12.0f,12.0f);  
    glVertex3f(24.0f,-12.0f,12.0f);
    glVertex3f(-24.0f,-12.0f,12.0f);

    glEnd();
    glEnable(GL_LIGHTING);
    glPopMatrix();
}

void CFishTank::draw() {
     drawTank();

    glPolygonMode(GL_BACK, GL_LINE);
    glPolygonMode(GL_FRONT, tankMode);
    int i;
	for (i = 0; i < rockCount; i++) {
       m_rocks[i].draw();
    }
    glPolygonMode(GL_FRONT, GL_FILL);
    for (i = 0; i < showFishCount; i++) {
        m_fish[i].draw();
        m_fish[i].move();
    }
}
