#define TIME_STEP 1000
#define TANK_LENGTH 48.0
#define TANK_WIDTH 24.0
#define TANK_HEIGHT 24.0

class CRockPoly : public CPolygon {
      private:

              VERTEX m_vOrigin;
              float m_fRotation;
              float m_radius;

      public:
             CRockPoly();
             ~CRockPoly() { delete &m_vOrigin; }
             void init(int rcID, int junk);
             void init(int tid);
             void position(float x, float y, float z);
             void draw();
             bool isIn(float x, float y, float z, float r);
             bool isPathIn(VERTEX start, VERTEX end, float r);
             VERTEX getPosition();

};

CRockPoly::CRockPoly()
    :CPolygon()
{
    m_vOrigin.x = 0.0;
    m_vOrigin.y = 0.0;
    m_vOrigin.z = 0.0;

    float rnd = rand(), rndmax = RAND_MAX;

    m_fRotation = (rnd/rndmax)*360;

    INDEX vertsIdx[3];

    vertsIdx[0].nVertex = addVertex(3.0,0.0,-1.0);
    vertsIdx[1].nVertex = addVertex(2.0,1.0,2.0);
    vertsIdx[2].nVertex = addVertex(2.0,0.0,2.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(3.0,1.0,-1.0);
    vertsIdx[1].nVertex = addVertex(2.0,1.0,2.0);
    vertsIdx[2].nVertex = addVertex(3.0,0.0,-1.0);
    addFace(vertsIdx);
                                                  
    vertsIdx[0].nVertex = addVertex(0.0,0.0,0.0);
    vertsIdx[2].nVertex = addVertex(2.0,0.0,2.0);
    vertsIdx[1].nVertex = addVertex(3.0,0.0,-1.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(0.0,1.0,0.0);
    vertsIdx[1].nVertex = addVertex(2.0,1.0,2.0);
    vertsIdx[2].nVertex = addVertex(3.0,1.0,-1.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(2.0,0.0,2.0);
    vertsIdx[1].nVertex = addVertex(-2.0,1.0,3.0);
    vertsIdx[2].nVertex = addVertex(-2.0,0.0,3.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(2.0,1.0,2.0);
    vertsIdx[1].nVertex = addVertex(-2.0,1.0,3.0);
    vertsIdx[2].nVertex = addVertex(2.0,0.0,2.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(2.0,0.0,2.0);
    vertsIdx[2].nVertex = addVertex(0.0,0.0,0.0);
    vertsIdx[1].nVertex = addVertex(-2.0,0.0,3.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(2.0,1.0,2.0);
    vertsIdx[1].nVertex = addVertex(0.0,1.0,0.0);
    vertsIdx[2].nVertex = addVertex(-2.0,1.0,3.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(-2.0,0.0,3.0);
    vertsIdx[1].nVertex = addVertex(-3.0,1.0,-1.0);
    vertsIdx[2].nVertex = addVertex(-3.0,0.0,-1.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(-2.0,1.0,3.0);
    vertsIdx[1].nVertex = addVertex(-3.0,1.0,-1.0);
    vertsIdx[2].nVertex = addVertex(-2.0,0.0,3.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(-2.0,0.0,3.0);
    vertsIdx[2].nVertex = addVertex(0.0,0.0,0.0);
    vertsIdx[1].nVertex = addVertex(-3.0,0.0,-1.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(-2.0,1.0,3.0);
    vertsIdx[1].nVertex = addVertex(0.0,1.0,0.0);
    vertsIdx[2].nVertex = addVertex(-3.0,1.0,-1.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(-3.0,0.0,-1.0);
    vertsIdx[1].nVertex = addVertex(0.5,1.0,-3.0);
    vertsIdx[2].nVertex = addVertex(0.5,0.0,-3.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(-3.0,1.0,-1.0);
    vertsIdx[1].nVertex = addVertex(0.5,1.0,-3.0);
    vertsIdx[2].nVertex = addVertex(-3.0,0.0,-1.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(-3.0,0.0,-1.0);
    vertsIdx[2].nVertex = addVertex(0.0,0.0,0.0);
    vertsIdx[1].nVertex = addVertex(0.5,0.0,-3.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(-3.0,1.0,-1.0);
    vertsIdx[1].nVertex = addVertex(0.0,1.0,0.0);
    vertsIdx[2].nVertex = addVertex(0.5,1.0,-3.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(0.5,0.0,-3.0);
    vertsIdx[1].nVertex = addVertex(3.0,1.0,-1.0);
    vertsIdx[2].nVertex = addVertex(3.0,0.0,-1.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(0.5,1.0,-3.0);
    vertsIdx[1].nVertex = addVertex(3.0,1.0,-1.0);
    vertsIdx[2].nVertex = addVertex(0.5,0.0,-3.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(0.5,0.0,-3.0);
    vertsIdx[2].nVertex = addVertex(0.0,0.0,0.0);
    vertsIdx[1].nVertex = addVertex(3.0,0.0,-1.0);
    addFace(vertsIdx);

    vertsIdx[0].nVertex = addVertex(0.5,1.0,-3.0);
    vertsIdx[1].nVertex = addVertex(0.0,1.0,0.0);
    vertsIdx[2].nVertex = addVertex(3.0,1.0,-1.0);
    addFace(vertsIdx);

    randomizeVertices(1.0f,0.1f,1.0f);

    VERTEX v;
    float rad = 0.0;
    m_radius = 0.0;

    float tx, ty;
    for (int i = 1; i < getVertexCount(); i++) {
        v = getVertex(i);
        if (v.x == 0.0 && v.z == 0.0) {
           ty = abs((int)v.y - 1);
           tx = 0.0;
        }
        else {
           ty = v.y;
           tx = v.x;
        }
        setVertexTexture(i, tx, ty);

        rad = sqrt(v.x*v.x + v.y*v.y);

        if (rad > m_radius) m_radius = rad;

    }
}

void CRockPoly::init(int rcID, int junk) {
    loadTextureFile(rcID);
}

void CRockPoly::init(int tid) {
    setTextureID(tid);
}

void CRockPoly::position(float x, float y, float z) {
    m_vOrigin.x = x;
    m_vOrigin.y = y;
    m_vOrigin.z = z;
}

void CRockPoly::draw()
{
    glPushMatrix();
    glTranslatef(m_vOrigin.x,m_vOrigin.y,m_vOrigin.z);
    glRotatef(m_fRotation,0.0,1.0,0.0);
    CPolygon::draw();
    glPopMatrix();

}

bool CRockPoly::isIn(float x, float y, float z, float r) {
    // translate to 0,0,0
    float xx = x - m_vOrigin.x;
    float yy = y - m_vOrigin.y;
    float zz = z - m_vOrigin.z;
    // approximate by a cylinder

    if (yy>=0.0-r/2 && yy <= 1.0+r/2 && ((xx*xx + zz*zz) < (m_radius+r)*(m_radius+r))) {
        return TRUE;
    }
    else {
       return FALSE;
    }
}

bool CRockPoly::isPathIn(VERTEX start, VERTEX end, float r) {
    int step = 10;
    float x, y, z, dx, dy, dz;
    dx = (end.x - start.x)/(float)step;
    dy = (end.y - start.y)/(float)step;
    dz = (end.z - start.z)/(float)step;
    x = start.x;
    y = start.y;
    z = start.z;
    for (int i = 0; i < step; i++) {
        if (isIn(x,y,z,r)) return TRUE;
        x += dx;
        y += dy;
        z += dz;
    }
    return FALSE;
}

VERTEX CRockPoly::getPosition() {
    return m_vOrigin;
}

