// Includes

#include <windows.h>
#include <malloc.h>
#include <stdio.h>
#include <gl/gl.h>
#include <gl/glu.h>
#include <scrnsave.h>
#include <mmsystem.h>




bool doAnimate = FALSE;


HDC			hDC=NULL;		// Private GDI Device Context
HGLRC		hRC=NULL;		// Permanent Rendering Context
HWND		hWnd=NULL;		// Holds Our Window Handle
HINSTANCE	hInstance;		// Holds The Instance Of The Application

DEVMODE			DMsaved;			// Saves the previous screen settings (NEW)
UINT			uTimer;				// timer identifier


#include "CFishTank.h"

bool	keys[256];			// Array Used For The Keyboard Routine
bool    keyPress[256];
bool	active=TRUE;		// Window Active Flag Set To TRUE By Default
bool	fullscreen=TRUE;	// Fullscreen Flag Set To Fullscreen Mode By Default

GLfloat	xrot;				// X Rotation
GLfloat	yrot;				// Y Rotation
GLfloat xspeed;				// X Rotation Speed
GLfloat yspeed;				// Y Rotation Speed
GLfloat	x=0.0, y=0.0, z=-41.0f;			// Depth Into The Screen
GLfloat oldyrot = 0.0;

GLfloat	rtri;				// Angle For The Triangle ( NEW )
GLfloat	rquad;				// Angle For The Quad ( NEW )

GLint sandTexture;

CFishTank tank = CFishTank();

int fishCount;
int frames = 0,oldfps=-1;
int fps = 50;
int sttime = 0;
int oldtimer = 0, timer, movetimer = -1;
int showFishCount = 10;
int fishView = 0;
bool useFishView = FALSE;

int rockCount = 0;
bool pause = FALSE;

bool doRotate = FALSE;

GLenum errCode;
const GLubyte *errString;

static GLint tankMode = GL_FILL;
static GLint fogMode = GL_EXP;

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}


int InitGL(GLvoid)										// All Setup For OpenGL Goes Here
{
    tank.init();
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations

    GLfloat lmodel_ambient[] = { 10, 10, 10, 1.0 };
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);

    glEnable(GL_LIGHTING);
	return TRUE;									// Initialization Went OK
}

int DrawGLScene(GLvoid)
{
    GLfloat transx=0.0, transy=0.0, transz=0.0;
    GLfloat transxrot = 0.0, transyrot = 0.0;
    frames++;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glLoadIdentity();

    if (useFishView) {
/*        VERTEX v = fishes[fishView].getPosition();
        transx = -v.x;
        transy = -v.y;
        transz = -v.z;
        VERTEX v2 = fishes[fishView].getVelocity();


       GLfloat divisor = v2.x*v2.x+ v2.z*v2.z;
       if (divisor != 0) {
          transyrot = acos((-v2.z)/sqrt(divisor)) * 180 / PI;
          if (v2.x < 0) transyrot = -transyrot;
       }
       else {
           transyrot = 0.0;
       }

       GLfloat divisor1 = v2.x*v2.x+ v2.y*v2.y + v2.z*v2.z;

       GLfloat divisor2 = v2.x*v2.x+ v2.z*v2.z;
       if (divisor1 != 0 && divisor2 != 0) {
          transxrot = acos((v2.x*v2.x+v2.z*v2.z)/(sqrt(divisor1)*sqrt(divisor2))) * 180 / PI;
          if (v2.y > 0) transxrot = -transxrot;
       }
       else {
          transxrot = 0.0;
       }
       glTranslatef(0.0,0.0,-fishes[fishView].getMinX());
       glRotatef(transxrot,1.0f,0.0f,0.0f);
       glRotatef(transyrot,0.0f,1.0f,0.0f);
       glTranslatef(transx,transy,transz);
  */
    }
    else {
        transx = x;
        transy = y;
        transz = z;
        transxrot = xrot;
        transyrot = yrot;
        glTranslatef(transx,transy,transz);
	    glRotatef(transxrot,1.0f,0.0f,0.0f);
	    glRotatef(transyrot,0.0f,1.0f,0.0f);
    }

    tank.draw();

    int ticks = GetTickCount()-sttime;

    if (frames > 20  && ticks > 0)
        fps = frames*1000/ticks;
    if (fps < 3) fps = 50;

	xrot+= xspeed/fps;
	yrot+= yspeed/fps;

    if (timer-movetimer >= 30) {
       yspeed = 90.0;
       movetimer = timer;
    }
    else if (yrot > oldyrot + 45) {
       yspeed = 0;
       yrot = oldyrot + 45;
       if (yrot > 360.0) yrot = yrot - 360.0;
       oldyrot = yrot;
    }

    timer = time (NULL);
    if (movetimer < 0) movetimer = timer;

    if (fps!=oldfps && timer > oldtimer)
    {
        oldfps=fps;
        oldtimer = timer;
       // char cap[100],sfps[50];
       // itoa(fps,sfps,10);
       // strcpy(cap,"Fish Tank ");
       // strcat(cap,sfps);
       // strcat(cap," fps");
       // SetWindowText(hWnd,cap);

        if (frames>20)
        {
            frames/=2;
            sttime=(GetTickCount()+sttime)/2;
        }
    }

    if ((errCode = glGetError()) != GL_NO_ERROR) {
       errString = gluErrorString(errCode);
     // outfile << errString << "\n";
    }

	return TRUE;
}




GLvoid KillGLWindow(GLvoid)								// Properly Kill The Window
{
	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}
}


/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/
BOOL CreateGLWindow(HWND hWnd, int bits)
{
	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	int width;
	int height;

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window

	EnumDisplaySettings(NULL, ENUM_CURRENT_SETTINGS, &DMsaved); // save the current display state (NEW)

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

    GetClientRect (hWnd, &WindowRect); 
	
	width = WindowRect.right - WindowRect.left;
	height = WindowRect.bottom - WindowRect.top;
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen


    if (!InitGL())									// Initialize Our Newly Created GL Window
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	return TRUE;									// Success
}


LRESULT WINAPI ScreenSaverProc (HWND hWnd,
								UINT uMsg,
								WPARAM wParam,
								LPARAM lParam)
{

	switch (uMsg)									// Check For Windows Messages
	{
        case WM_CREATE:
		{
			if (!CreateGLWindow(hWnd,16))
			{
				return -1;									// Quit If Window Was Not Created
			}
			//InitVars();                                     // Initialize Variables

            uTimer = SetTimer(hWnd, 1, 10, NULL);
			return 0;
		}

        case WM_TIMER: 
			DrawGLScene();                      // Draw Scene
			SwapBuffers(hDC);					// Swap Buffers (Double Buffering)
			break;

        case WM_DESTROY: 
            if (uTimer) 
                KillTimer(hWnd, uTimer); 
			KillGLWindow();									// Kill The Window
            PostQuitMessage(0);
            return 0;
			//glDeleteTextures(4,texture);
            break; 
	}

	// Pass All Unhandled Messages To DefScreenSaverProc
    return DefScreenSaverProc(hWnd, uMsg, wParam, lParam); 
}

BOOL WINAPI ScreenSaverConfigureDialog (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{ 
    return FALSE; 
} 

BOOL WINAPI RegisterDialogClasses(HANDLE hInst)
{ 
    return TRUE; 
} 

